' ST-Keep Description Cleanup
' Deletes ST-Keep File Descriptions without matching files

library "gemaes","gemdos"		'these libraries are used

defint a-w
deflng Total,x-z
dim shared dta(22)								'our DTA

if peekw(systab)=4 then
	dummy=FNform_alert(1,"[3][This doesn't run in|low res][ Quit ]")
	system
end if

copyright$=chr$(189)

m=peek(systab)						'get resolution

window open 2,"ST-Keep File Description Cleanup "+copyright$+" GRUNT Software 1993",0,0,639,398\m,1


begin:

but=FNform_alert(1,"[1][ ST-Keep Cleanup |   Version 1.2|    "+copyright$+" 1993 by| GRUNT Software][ Proceed ]")


do until fexists(infa$)

Print "Where is the STK_INFA.SYS file? (Just the path is Okay.)"

fil$=FNselect_file$
gosub backslash
path$=left$(fil$,x)
infa$=path$+"STK_INFA.SYS"

if not(fexists(infa$))
	but=FNform_alert(1,"[1][|  I can't find | |  "+infa$+"! ][Try Again|Quit]")
	if but=2 then system
end if

loop

room$=path$+"STK_ROOM.SYS"				' Set up some temporary info
temp_path$=path$+"TEMPPATH.TXT"			' needed to find all the rooms
ftemp_path$=path$+"FTEMP.TXT"
										' and so forth
open "I", #1, infa$
										' Read all the necessary info
										' from STK_INFA.SYS and
for x=1 to 3							' STK_ROOM.SYS
line input #1,a$
next x
rooms=val(a$)

for x=4 to 8
line input #1,a$
next x
messages=val(a$)

close #1

Buffer=60+11*messages
Rcsize=Buffer

filst$=space$(Rcsize)

open "O",#2,temp_path$					' Write the file paths to a temp file

mouse 2									' busybee

open room$ for input as #1 len=Rcsize	'open source with some buffer space

filel&=lof(1)

filst$=input$(filel&,#1)			' read entire file

close #1

Total= len(filst$)

for x=1 to Total

x=instr(x,filst$,":\")				' Strip out extra characters
	if x>Total or x=0 then exit for
	room_path$=mid$(filst$,x-1,30)
	check%=asc(left$(ucase$(room_path$),1))
	if check%<asc("A") or check%>asc("P") then goto no_good
	look_it:
	gap=instr(room_path$," ")
	if gap<>0 then room_path$=left$(room_path$,gap-1)
	print #2,room_path$					' Write the actual path info

no_good:
next x

close #2
close #1
print

open "I", #1, temp_path$			' Start processing the rooms

while not (eof(1))					' Keep going until we run out
	line input #1, a$
	where=instr(a$," ")
	if where<>0 then a$=left$(a$,where-1)
	path$=a$	 					' Where are the actual files?

	actual$=path$

	print "Processing ";path$
	head$=a$						' Where are the descriptions?
	txt$=head$+"FILES\"
	path$=txt$+"*.*"
	
	dirstr$=""
	dir2str path$,dirstr$
	
	open "O", #2, ftemp_path$
	print #2, dirstr$
	close #2
	
	open "I", #2, ftemp_path$
	while not (eof(2))
		line input #2, f$
		valid=instr(f$,".")
		if valid<>0
			b$=head$+f$
			c$=txt$+f$
			if not(fexists(b$))
				print b$;" does not exist!"
				print "Deleting ";c$
				kill c$
			end if
		end if
	wend
wend

close #2
close #1

cls
kill temp_path$

end

backslash:
y=instr(x+1,fil$,"\")
if y<>0
	x=y
	goto backslash
end if
return

DEF FNselect_file$
static path$,name$,but,drv$,where,y,mask$

	if mask$="" then mask$="*.SYS"
	path$=space$(64)							'set up buffer
	drv$=chr$(FNdgetdrv+"A"%)					'get current drive
	dgetpath sadd(path$),0						'get current path
	if left$(path$,1)=chr$(0) then				'add *.ASC
		path$=drv$+":\"+mask$
	else
		path$=drv$+":"+path$
		where=instr(path$,chr$(0))
		path$=left$(path$,where-1)
		path$=path$+"\"+mask$
	end if
	fsel_input path$,name$,but					'the file selector appears!
	cls											'naughty naughty
	if but=0 then goto skip_it					'cancel button
	where=instr(path$,"\")						'build the file name
	backslash3:
	y=instr(where+1,path$,"\")
	if y<>0
		where=y
		goto backslash3
	end if
	path$=left$(path$,where)
	FNselect_file$=path$+name$

skip_it:
end def

sub dir2str(pathstr$,targstr$)
static isitthere,olddta&,addr&,hold

	olddta&=FNfgetdta&							'get the old dta

	fsetdta varptr(dta(0))						'this is where we want it

	isitthere=FNfsfirst(pathstr$,0)				'look for the file

	if isitthere<0 then							'no files available
		fsetdta olddta&
		exit sub
	end if

	do
		addr&=varptr(dta(15))
		do										'look for null byte
			hold=peekb(addr&)
			if hold=0 then exit loop
			targstr$=targstr$+chr$(hold)
			incr addr&
		loop

		targstr$=targstr$+chr$(13)+chr$(10)		'add cr-lf

		isitthere=FNfsnext						'is there another file?
		if isitthere<0 then						'if not restore dta and exit
			fsetdta olddta&
			exit loop
		end if
	loop

end sub

end
